using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;

namespace DyamicPropertyDescriptorDemo {
	public class PersonCollection : BindingList<Person>, ITypedList {
		protected IPersonViewBuilder _viewBuilder;

		public PersonCollection(IPersonViewBuilder viewBuilder) {
			_viewBuilder = viewBuilder;
		}

		#region ITypedList Members

		protected PropertyDescriptorCollection _props;

		public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors) {
			if (_props == null) {
				_props = _viewBuilder.GetView();
			}
			return _props;
		}

		public string GetListName(PropertyDescriptor[] listAccessors) {
			return ""; // was used by 1.1 datagrid
		}
        public void AddCol()
        {
           DynamicPropertyDescriptor newDesc =new DynamicPropertyDescriptor(
			typeof(Person),
			"FullName12",
			typeof(string),
			delegate(object p) { 
				return ((Person)p).FirstName + " " 
					+ ((Person)p).MiddleName + " " 
					+ ((Person)p).LastName; },
			null
		);

           FireEvent(new ListChangedEventArgs(ListChangedType.PropertyDescriptorAdded, newDesc));
        }
        private void FireEvent(System.ComponentModel.ListChangedEventArgs args)
        {
            base.OnListChanged(args);
        }
		#endregion
	}
}
