using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;

namespace DyamicPropertyDescriptorDemo {
public class PersonFullNameAgeHoursView : IPersonViewBuilder {
	public PropertyDescriptorCollection GetView() {
		List<PropertyDescriptor> props = new List<PropertyDescriptor>();

		props.Add(new DynamicPropertyDescriptor(
			typeof(Person),
			"FullName",
			typeof(string),
			delegate(object p) { 
				return ((Person)p).FirstName + " " 
					+ ((Person)p).MiddleName + " " 
					+ ((Person)p).LastName; },
			null
		));

		props.Add(new DynamicPropertyDescriptor(
			typeof(Person),
			"Age",
			typeof(string),
			delegate(object p) {
				return DateTime.Today.Year - ((Person)p).DateOfBirth.Year;
			},
			null
		));

		for ( int day = 0; day < 7; day++ ) {
			// without this variable declared inside the loop, 
			// the anon methods won't work correctly
			// they will all reference the value of the 
			// foreach loop variables as set on the last iteration
			int bindableDay = day;
			props.Add(new DynamicPropertyDescriptor(
				typeof(Person),
				Enum.GetName(typeof(DayOfWeek), day),
				typeof(Decimal),
				delegate(object p) { 
					return ((Person)p)[bindableDay];
				},
				delegate(object p, object newPropVal) { 
					((Person)p)[bindableDay] = (decimal) newPropVal; 
				}
			));
		}


		PropertyDescriptor[] propArray = new PropertyDescriptor[props.Count];
		props.CopyTo(propArray);
		return new PropertyDescriptorCollection(propArray);
	}
}
}
